import { useLayoutEffect, useState } from "react";
import React from "react";
const log = console.log;
let cache = [];
const clear = () => cache = [];
const react18 = parseFloat(React.version) > 17;
const referenceSet = new Set();
export default (factory, cleanup) => {
    if (react18) {
        const [value] = useState(factory);
        useLayoutEffect(() => {
            referenceSet.add(value);
            setTimeout(() => referenceSet.delete(value));
            return () => {
                if (referenceSet.has(value))
                    return;
                cleanup === null || cleanup === void 0 ? void 0 : cleanup(value);
            };
        }, []);
        queueMicrotask(() => {
            if (referenceSet.has(value))
                return;
            cleanup === null || cleanup === void 0 ? void 0 : cleanup(value);
        });
        return value;
    }
    const [result] = useState(() => {
        if (log === console.log) {
            queueMicrotask(clear);
            const result = factory();
            cache.push(result);
            return result;
        }
        return cache.shift();
    });
    useLayoutEffect(() => {
        return () => {
            cleanup === null || cleanup === void 0 ? void 0 : cleanup(result);
        };
    }, []);
    return result;
};
