import { useEffect } from "react"
import { Cancellable } from "@lincode/promiselikes"

export default (cb: () => void | (() => void), deps: Array<any>, timeout = 0) => {
    useEffect(() => {
        const handle = new Cancellable()

        const t = setTimeout(() => {
            const cleanup = cb()
            cleanup && handle.then(cleanup)
        }, timeout)

        return () => {
            clearTimeout(t)
            handle.cancel()
        }
    }, deps)
}